#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#ifdef _DCC
#define __inline
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// #include <libraries/dos.h>
#include <clib/dos_protos.h>
#include "interface.h"


struct T_MesPistes MesPistes[256];
UBYTE **MesTitres; 

UWORD topborder;

int mapiste = 1;
int first_track;
int last_track;
int nb_pistes =0;
int current_track;
int current_pos;
int abs_pos;
int toclen;

ULONG MonVolume;

struct PistesInfo MesPistesInfo[256];


struct IntuitionBase	*IntuitionBase	= NULL;
struct Library			*MUIMasterBase	= NULL;
struct Library  		*UtilityBase = NULL;

static Object *app = NULL;
static Object *window = NULL;

struct ObjApp *myapp=NULL;

struct Scsi {
        int unit;
        char device[32];
} scsi;

extern BOOL init(char *device, int number);
extern void inquiry (BOOL parsedoutput);
extern void deinitscsi(void);
extern void play_audio (int starttrack, int endtrack);
extern void play_audio_scsi12 (long starttrack, long endtrack);
extern int  read_toc (int toclong);
extern void motor (int motorstatus);
extern void read_subchannel (BOOLEAN parsed, UBYTE subchannel, UBYTE subchannelformat, UBYTE track);
extern void play_from(int pos_deb, int pos_fin);

STRPTR IndexPath = "CD_Titles:";
static UBYTE cd[20];

struct MUI_CustomClass *cl_playero;

#define PLAYERBASE			 (TAG_USER + 0x61843728)

#define MUIA_Player_Executable  (PLAYERBASE + 1)

#define MUIM_Player_PlayAudio   (PLAYERBASE + 20)
#define MUIM_Player_NextTrack   (PLAYERBASE + 21)
#define MUIM_Player_PrevTrack   (PLAYERBASE + 22)

#define MUIM_Player_Refresh   (PLAYERBASE + 23)

/*
#define MUIA_Debug_LogMode     (PLAYERBASE + 2)
#define MUIA_Debug_LogFile	   (DEBUGBASE + 3)

#define MUIA_Debug_DumpMode    (DEBUGBASE + 4)
#define MUIA_Debug_DumpFile    (DEBUGBASE + 5)

#define MUIA_Debug_CurrentHit  (DEBUGBASE + 6)


#define MUIV_Debug_Manual      (DEBUGBASE + 10)
#define MUIV_Debug_Auto        (DEBUGBASE + 11)


#define MUIM_Debug_ShowHit	       (DEBUGBASE + 20)
#define MUIM_Debug_PerformAction   (DEBUGBASE + 21)
#define MUIM_Debug_Analyze		   (DEBUGBASE + 22)
*/

struct PlayerData
{
	char m_executable[128];
	int  m_current_hit;

	ULONG bgrandom_timer_count;
	ULONG bgrandom_timer_wait;

	ULONG bgrandom_inputhandler_added;
	struct MUI_InputHandlerNode bgrandom_ihnode;

	/* cache cleanup counter
	 */
	ULONG cachecleanup_timer_count;
	ULONG cachecleanup_timer_wait;

	ULONG cachecleanup_inputhandler_added;
	struct MUI_InputHandlerNode cachecleanup_ihnode;
};


static ULONG Application_CleanupCache(struct PlayerData *data)
{

printf("refresh 0!!!\n");
	if(--data->cachecleanup_timer_count == 0)
	{
		data->cachecleanup_timer_count = data->cachecleanup_timer_wait;

		/*
		 * TODO: Make this one asynchronous? Probably good idea...
		 */

		// cache_deleteunused();
		
		printf("refresh !!!\n");
		

	}

	return (0);
}


BOOL
GetIndex( int t, ULONG a1, ULONG a2 )
{
    UBYTE buf[256];
    BPTR f;
	 UBYTE Auteur[50];
	 UBYTE Titre[50];
	 int res=0;
	 int i;
    /* Read an index file from the disk */


/*
for (i=0;i<=nb_pistes;i++)
	{
  	 free(MesTitres[i]);  // pose des probleme avec le chooser
	};
	free(MesTitres);
									
	MesTitres = NULL;
*/	
											
	if (res == 2) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de CD insr !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else if (res == 1) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de piste audio sur le CD !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else 
	{

    	strcpy( buf, IndexPath );
    	sprintf( cd, "ID%2.2d%6.6lx%6.6lx", t, a1 , a2 );
    	AddPart( buf, cd, sizeof(buf)-1 );


    	if ((f = Open(buf, MODE_OLDFILE)) == TRUE)
    	{
      	//ULONG i;

        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Auteur, buf);
        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Titre, buf);

        	for (i = 0 ; i < t ; i++)
        	{
            FGets(f, buf, sizeof(buf)-1);
            MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(buf)+1);
            strncpy(MesTitres[i], buf,strlen(buf)-1);
        	}

			MesTitres[i] = NULL;
			
        Close(f);


       // return TRUE;

    	}else
    	{
    		for(i=0;i<=nb_pistes;i++)
			{
				MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(MesPistes[i+1].Nom)+1);
				strcpy(MesTitres[i],MesPistes[i+1].Nom);
			};
			
			//MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
			MesTitres[i-1] = NULL;
			//MesTitres[i+1] = NULL;	
    	}
	
   }
/*
free_chooserlist (&chooser_list1);
make_chooserlist(&chooser_list1, MesTitres); 	
											
SetAttrs(gadgets[GID_CHOOSER1],
			CHOOSER_Labels, (ULONG)&chooser_list1,
			TAG_END);
											
RefreshGList(gadgets[GID_CHOOSER1],windows[WID_MAIN],NULL,GID_CHOOSER1);
*/
return FALSE;
}


BOOL testcd(void)
{

	//int i;
	int res=0;
	int OldTaille;

	BOOL cdin=TRUE;
	BOOL titreok;

	OldTaille = MesPistesInfo[0].taille;

	res = read_toc(1);

	printf("read_toc : %d\n", res);

	if (MesPistesInfo[0].taille != OldTaille)
	{
		titreok = GetIndex(nb_pistes, MesPistesInfo[3].deb-MesPistesInfo[0].deb,
			 MesPistesInfo[nb_pistes].deb + MesPistesInfo[nb_pistes].taille
			  - MesPistesInfo[0].deb);
	}
	return (cdin);
};




// Partie cration/gestion interface

static ULONG Player_NextTrack(struct PlayerData *data)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", MesPistes[mapiste+1].No, last_track);

		  mapiste = mapiste + 1;

		  // play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille-MesPistesInfo[mapiste].deb);
			play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);

        return TRUE;
}

static ULONG Player_PrevTrack(struct PlayerData *data)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", MesPistes[mapiste+1].No, last_track);

		  mapiste = mapiste - 1;

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);

		  // play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille-MesPistesInfo[mapiste].deb);

        return TRUE;
}



static ULONG Player_PlayAudio(struct PlayerData *data)
{
	// printf("Let's play !!!\n");

	//	  printf("piste : %d, last track : %d\n", mapiste, last_track);

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);
//		  play_audio(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);
//		  play_audio_ti(2,1,3,3);
//		  play_audio_scsi12(14000, 40000);

//		  play_from(15000, 20000);

		  //play_audio_scsi12(0, MesPistesInfo[0].taille);

        return (ULONG)TRUE;
}



static ULONG PlayerNew(struct IClass *cl, Object *obj, struct opSet *msg)
{

	//struct ObjApp * myObject;

	Object	*GROUP_ROOT_0, *obj_aux0, *obj_aux1, *GR_grp_0;

	Object *App;
	Object *WI_label_0;
	Object *TX_label_0;
	Object *SL_label_0;
	Object *BT_label_5;
	Object *BT_label_6;
	Object *BT_label_7;
	Object *BT_label_8;
	Object *BT_label_9;
	Object *STR_TX_label_0;

	obj = (Object *)DoSuperNew(cl, obj, 
		Child, TX_label_0 = TextObject,
			MUIA_Background, MUII_TextBack,
			MUIA_Frame, MUIV_Frame_Text,
			MUIA_Text_Contents, "00 00:00",
			MUIA_Text_SetMin, TRUE,
		End,
		Child, GroupObject,
			MUIA_Group_Columns, 2,
			Child, Label2("Slider Title"),
			Child, SL_label_0 = SliderObject,
				MUIA_HelpNode, "SL_label_0",
				MUIA_Slider_Min, 0,
				MUIA_Slider_Max, 100,
				MUIA_Slider_Level, 0,
				MUIA_Slider_Quiet, TRUE,		
			End,
		End,
		Child, GroupObject,
			MUIA_HelpNode, "GR_grp_0",
			MUIA_Group_Horiz, TRUE,
			Child, BT_label_5 = SimpleButton("|<"),
			Child, BT_label_6 = SimpleButton("<<"),
			Child, BT_label_7 = SimpleButton(">"),
			Child, BT_label_8 = SimpleButton(">>"),
			Child, BT_label_9 = SimpleButton(">|"),
		End,
		TAG_MORE, (struct opSet *) msg->ops_AttrList);

	if (obj)
	{
		struct PlayerData *data = (struct PlayerData *)INST_DATA(cl, obj);
		struct TagItem *tags,*tag;



		
		data->cachecleanup_timer_count = 30;
		data->cachecleanup_timer_wait = 30;

		data->cachecleanup_ihnode.ihn_Object = obj;
		data->cachecleanup_ihnode.ihn_Flags = MUIIHNF_TIMER;
		data->cachecleanup_ihnode.ihn_Millis = 100;
		data->cachecleanup_ihnode.ihn_Method = MUIM_Player_Refresh ;

		DoMethod(obj, MUIM_Application_AddInputHandler, &data->cachecleanup_ihnode);
		data->cachecleanup_inputhandler_added = TRUE;


		/* parse initial taglist */

		/* notifications */

		DoMethod(BT_label_7, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_PlayAudio);
		DoMethod(BT_label_9, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_NextTrack);
		DoMethod(BT_label_5, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_PrevTrack);
/*
		DoMethod(data->m_bt_analyze, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Debug_Analyze);

		DoMethod(Object->BT_label_7, MUIM_Notify, MUIA_Pressed, FALSE,
                                        Object->BT_label_7,  2, MUIM_CallHook, &hook_PlayCD);
	
		DoMethod(Object->BT_label_9, MUIM_Notify, MUIA_Pressed, FALSE,
	                                       Object->BT_label_9,  2, MUIM_CallHook, &hook_NextTrack);

		DoMethod(Object->BT_label_5, MUIM_Notify, MUIA_Pressed, FALSE,
                                        Object->BT_label_5,  2, MUIM_CallHook, &hook_PrevTrack);
*/

	}

	return (ULONG)obj;
}


static ULONG PlayerDispose(struct IClass *cl, Object *obj, struct opSet *msg)
{
	struct PlayerData *data;

	data = (struct PlayerData *)INST_DATA(cl, obj);

	if(data->bgrandom_inputhandler_added)
	{
		DoMethod(obj, MUIM_Application_RemInputHandler, &data->bgrandom_ihnode);
	}

	if(data->cachecleanup_inputhandler_added)
	{
		DoMethod(obj, MUIM_Application_RemInputHandler, &data->cachecleanup_ihnode);
	}


	return (DoSuperMethodA(cl, obj, msg));
}

static ULONG PlayerSet(struct IClass *cl, Object *obj, struct opSet *msg)
{
	struct PlayerData *data;
	struct TagItem *tags, *tag;

	data = (struct PlayerData *)INST_DATA(cl, obj);

/*
	for (tags=((struct opSet *)msg)->ops_AttrList;tag=NextTagItem(&tags);)
	{
		switch (tag->ti_Tag)
		{

			case MUIM_Player_Refresh:
			{
				if(data->bgrandom_inputhandler_added)
				{
					DoMethod(obj, MUIM_Application_RemInputHandler, &data->bgrandom_ihnode);
					data->bgrandom_inputhandler_added = FALSE;
				}

				if(tag->ti_Data)
				{
					data->bgrandom_timer_wait = data->bgrandom_timer_count = (ULONG)tag->ti_Data;

					data->bgrandom_ihnode.ihn_Object = obj;
					data->bgrandom_ihnode.ihn_Flags = MUIIHNF_TIMER;
					data->bgrandom_ihnode.ihn_Millis = 100;
					data->bgrandom_ihnode.ihn_Method = MUIM_Player_Refresh ;

					DoMethod(obj, MUIM_Application_AddInputHandler, &data->bgrandom_ihnode);

					data->bgrandom_inputhandler_added = TRUE;

				}
			}
*/
/*

			case MUIA_Debug_LogMode:
				data->m_ramdebug_mode = tag->ti_Data;
				SetAttrs(data->m_cy_ramdebug_mode, MUIA_Cycle_Active, data->m_ramdebug_mode, TAG_END);
				break;

			case MUIA_Debug_DumpMode:
				data->m_ramdebug_mode = tag->ti_Data;
				SetAttrs(data->m_cy_dump_mode, MUIA_Cycle_Active, data->m_dump_mode, TAG_END);
				break;

			case MUIA_Debug_Executable:
				if(tag->ti_Data)
				{
					strcpy(data->m_executable, (char *) tag->ti_Data);
					SetAttrs(data->m_st_executable, MUIA_Text_Contents, data->m_executable, TAG_END);
				}
				break;

			case MUIA_Debug_LogFile:
				if(tag->ti_Data)
				{
					strcpy(data->m_ramdebugfile, (char *) tag->ti_Data);
					SetAttrs(data->m_st_ramdebug_file, MUIA_Text_Contents, data->m_ramdebugfile, TAG_END);
				}
				break;

			case MUIA_Debug_DumpFile:
				if(tag->ti_Data)
				{
					strcpy(data->m_dumpfile, (char *) tag->ti_Data);
					SetAttrs(data->m_st_dump_file, MUIA_Text_Contents, data->m_dumpfile, TAG_END);
				}
				break;

			case MUIA_Debug_CurrentHit:
				data->m_current_hit = tag->ti_Data;
				SetAttrs(data->m_sl_current_hit, MUIA_Slider_Level, data->m_current_hit, TAG_END);
				break;

*/
//		}
//	}


	return (DoSuperMethodA(cl, obj, msg));
}

DISPATCHERPROTO(PlayerDispatcher)
{
	//struct IClass *cl = (struct IClass * ) REG_A0;
	//Object *obj = (Object *) REG_A2;
	//struct Msg *msg  = (struct Msg *) REG_A1;

	struct PlayerData *data = (struct PlayerData *)INST_DATA(cl, obj);

	switch(msg->MethodID)
	{
		case OM_NEW :						return PlayerNew(cl, obj, (struct opSet *) msg);
		case OM_DISPOSE :					return PlayerDispose(cl, obj, (struct opSet *)msg);
		case OM_SET:						return PlayerSet(cl, obj, (struct opSet *)msg);

		case MUIM_Player_PlayAudio :	return Player_PlayAudio(data);
		case MUIM_Player_NextTrack :	return Player_NextTrack(data);
		case MUIM_Player_PrevTrack :	return Player_PrevTrack(data);
		case MUIM_Player_Refresh 	:  return Application_CleanupCache(data);

	}
		return DoSuperMethodA(cl, obj, msg);
}

Object * OpenMainWindow(void)
{
	Object *obj_player;

	window = WindowObject,
		MUIA_Window_Title, "window_title",
		MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
		MUIA_Window_AppWindow, TRUE,
		WindowContents,  obj_player = (Object *) NewObject(cl_playero->mcc_Class, NULL, TAG_DONE),										
	End;

	app = (Object *)ApplicationObject,
		MUIA_Application_Author, "NONE",
		MUIA_Application_Base, "NONE",
		MUIA_Application_Title, "NONE",
		MUIA_Application_Version, "$VER: NONE XX.XX (XX.XX.XX)",
		MUIA_Application_Copyright, "NOBODY",
		MUIA_Application_Description, "NONE",
		SubWindow, window,
	End;


	if (app)
	{
	
		DoMethod(window,
			MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
			app, 2,
			MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

		SetAttrs(window, MUIA_Window_Open, TRUE, TAG_END);
	}

	return app;
}





int Initialize(void)
{
	int res = 1;

	IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 39L);
	MUIMasterBase = OpenLibrary(MUIMASTER_NAME, MUIMASTER_VMIN);
	UtilityBase = OpenLibrary("utility.library", 39);

	if (IntuitionBase == NULL)
	{
		printf("Can't open 'intuition.library' V39\n");
		res = 0;
	}
	if (MUIMasterBase == NULL)
	{
		printf("Can't open '%s' V%d\n", MUIMASTER_NAME, MUIMASTER_VMIN);
		res = 0;
	}
	if (UtilityBase == NULL)
	{
		printf("Can't open 'utility.library' V39\n");
		res = 0;
	}

	cl_playero = MUI_CreateCustomClass(NULL, MUIC_Group, NULL, sizeof(struct PlayerData), ENTRY(PlayerDispatcher));
	if (cl_playero == NULL)
	{
		printf("Can't create debug internal class\n");
		res = 0;
	}

	return res;
}

void DeInitialize(void)
{
	MUI_DeleteCustomClass(cl_playero);
	CloseLibrary(UtilityBase);
	CloseLibrary(MUIMasterBase);
	CloseLibrary((struct Library *)IntuitionBase);
}


int main(int argc, char **argv)
{
	int res = 0;
  BOOL testinit = FALSE;
  BOOL cd_in = FALSE;
 

	if (Initialize())
	{

		app = OpenMainWindow();
		if (app)
		{
			ULONG sigs = 0;



			  scsi.unit = 3;
			  strcpy(scsi.device, "ide.device");
  
			  testinit = init (scsi.device,scsi.unit);

			  if(testinit) printf("device init ok");
			  else exit(1);

			  inquiry (TRUE);

			  cd_in=testcd();

			  read_subchannel (TRUE, 64, 1, 0);


			while (DoMethod(app,MUIM_Application_NewInput,&sigs) != ((unsigned int) MUIV_Application_ReturnID_Quit))
			{
				if (sigs)
				{
					sigs = Wait(sigs | SIGBREAKF_CTRL_C);
					if (sigs & SIGBREAKF_CTRL_C) break;
				}
			}

		   deinitscsi();

			
			SetAttrs(window, MUIA_Window_Open, FALSE, TAG_END);
			MUI_DisposeObject(app);
		}
		else
		{
			res = 2;
		}
	}
	else
	{
		res = 1;
	}

	DeInitialize();

	return res;
}
